

# This file was autogenerated by some hot garbage in the `uniffi` crate.
# Trust me, you don't want to mess with it!

# Common helper code.
#
# Ideally this would live in a separate .py file where it can be unittested etc
# in isolation, and perhaps even published as a re-useable package.
#
# However, it's important that the details of how this helper code works (e.g. the
# way that different builtin types are passed across the FFI) exactly match what's
# expected by the rust code on the other side of the interface. In practice right
# now that means coming from the exact some version of `uniffi` that was used to
# compile the rust component. The easiest way to ensure this is to bundle the Python
# helpers directly inline like we're doing here.

from __future__ import annotations
import os
import sys
import ctypes
import enum
import struct
import contextlib
import datetime
import threading
import itertools
import traceback
import typing
import asyncio
import platform

# Used for default argument values
_DEFAULT = object()


class _UniffiRustBuffer(ctypes.Structure):
    _fields_ = [
        ("capacity", ctypes.c_uint64),
        ("len", ctypes.c_uint64),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    @staticmethod
    def default():
        return _UniffiRustBuffer(0, 0, None)

    @staticmethod
    def alloc(size):
        return _rust_call(_UniffiLib.ffi_ceylon_rustbuffer_alloc, size)

    @staticmethod
    def reserve(rbuf, additional):
        return _rust_call(_UniffiLib.ffi_ceylon_rustbuffer_reserve, rbuf, additional)

    def free(self):
        return _rust_call(_UniffiLib.ffi_ceylon_rustbuffer_free, self)

    def __str__(self):
        return "_UniffiRustBuffer(capacity={}, len={}, data={})".format(
            self.capacity,
            self.len,
            self.data[0:self.len]
        )

    @contextlib.contextmanager
    def alloc_with_builder(*args):
        """Context-manger to allocate a buffer using a _UniffiRustBufferBuilder.

        The allocated buffer will be automatically freed if an error occurs, ensuring that
        we don't accidentally leak it.
        """
        builder = _UniffiRustBufferBuilder()
        try:
            yield builder
        except:
            builder.discard()
            raise

    @contextlib.contextmanager
    def consume_with_stream(self):
        """Context-manager to consume a buffer using a _UniffiRustBufferStream.

        The _UniffiRustBuffer will be freed once the context-manager exits, ensuring that we don't
        leak it even if an error occurs.
        """
        try:
            s = _UniffiRustBufferStream.from_rust_buffer(self)
            yield s
            if s.remaining() != 0:
                raise RuntimeError("junk data left in buffer at end of consume_with_stream")
        finally:
            self.free()

    @contextlib.contextmanager
    def read_with_stream(self):
        """Context-manager to read a buffer using a _UniffiRustBufferStream.

        This is like consume_with_stream, but doesn't free the buffer afterwards.
        It should only be used with borrowed `_UniffiRustBuffer` data.
        """
        s = _UniffiRustBufferStream.from_rust_buffer(self)
        yield s
        if s.remaining() != 0:
            raise RuntimeError("junk data left in buffer at end of read_with_stream")

class _UniffiForeignBytes(ctypes.Structure):
    _fields_ = [
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    def __str__(self):
        return "_UniffiForeignBytes(len={}, data={})".format(self.len, self.data[0:self.len])


class _UniffiRustBufferStream:
    """
    Helper for structured reading of bytes from a _UniffiRustBuffer
    """

    def __init__(self, data, len):
        self.data = data
        self.len = len
        self.offset = 0

    @classmethod
    def from_rust_buffer(cls, buf):
        return cls(buf.data, buf.len)

    def remaining(self):
        return self.len - self.offset

    def _unpack_from(self, size, format):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        value = struct.unpack(format, self.data[self.offset:self.offset+size])[0]
        self.offset += size
        return value

    def read(self, size):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        data = self.data[self.offset:self.offset+size]
        self.offset += size
        return data

    def read_i8(self):
        return self._unpack_from(1, ">b")

    def read_u8(self):
        return self._unpack_from(1, ">B")

    def read_i16(self):
        return self._unpack_from(2, ">h")

    def read_u16(self):
        return self._unpack_from(2, ">H")

    def read_i32(self):
        return self._unpack_from(4, ">i")

    def read_u32(self):
        return self._unpack_from(4, ">I")

    def read_i64(self):
        return self._unpack_from(8, ">q")

    def read_u64(self):
        return self._unpack_from(8, ">Q")

    def read_float(self):
        v = self._unpack_from(4, ">f")
        return v

    def read_double(self):
        return self._unpack_from(8, ">d")

class _UniffiRustBufferBuilder:
    """
    Helper for structured writing of bytes into a _UniffiRustBuffer.
    """

    def __init__(self):
        self.rbuf = _UniffiRustBuffer.alloc(16)
        self.rbuf.len = 0

    def finalize(self):
        rbuf = self.rbuf
        self.rbuf = None
        return rbuf

    def discard(self):
        if self.rbuf is not None:
            rbuf = self.finalize()
            rbuf.free()

    @contextlib.contextmanager
    def _reserve(self, num_bytes):
        if self.rbuf.len + num_bytes > self.rbuf.capacity:
            self.rbuf = _UniffiRustBuffer.reserve(self.rbuf, num_bytes)
        yield None
        self.rbuf.len += num_bytes

    def _pack_into(self, size, format, value):
        with self._reserve(size):
            # XXX TODO: I feel like I should be able to use `struct.pack_into` here but can't figure it out.
            for i, byte in enumerate(struct.pack(format, value)):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write(self, value):
        with self._reserve(len(value)):
            for i, byte in enumerate(value):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write_i8(self, v):
        self._pack_into(1, ">b", v)

    def write_u8(self, v):
        self._pack_into(1, ">B", v)

    def write_i16(self, v):
        self._pack_into(2, ">h", v)

    def write_u16(self, v):
        self._pack_into(2, ">H", v)

    def write_i32(self, v):
        self._pack_into(4, ">i", v)

    def write_u32(self, v):
        self._pack_into(4, ">I", v)

    def write_i64(self, v):
        self._pack_into(8, ">q", v)

    def write_u64(self, v):
        self._pack_into(8, ">Q", v)

    def write_float(self, v):
        self._pack_into(4, ">f", v)

    def write_double(self, v):
        self._pack_into(8, ">d", v)

    def write_c_size_t(self, v):
        self._pack_into(ctypes.sizeof(ctypes.c_size_t) , "@N", v)
# A handful of classes and functions to support the generated data structures.
# This would be a good candidate for isolating in its own ffi-support lib.

class InternalError(Exception):
    pass

class _UniffiRustCallStatus(ctypes.Structure):
    """
    Error runtime.
    """
    _fields_ = [
        ("code", ctypes.c_int8),
        ("error_buf", _UniffiRustBuffer),
    ]

    # These match the values from the uniffi::rustcalls module
    CALL_SUCCESS = 0
    CALL_ERROR = 1
    CALL_UNEXPECTED_ERROR = 2

    @staticmethod
    def default():
        return _UniffiRustCallStatus(code=_UniffiRustCallStatus.CALL_SUCCESS, error_buf=_UniffiRustBuffer.default())

    def __str__(self):
        if self.code == _UniffiRustCallStatus.CALL_SUCCESS:
            return "_UniffiRustCallStatus(CALL_SUCCESS)"
        elif self.code == _UniffiRustCallStatus.CALL_ERROR:
            return "_UniffiRustCallStatus(CALL_ERROR)"
        elif self.code == _UniffiRustCallStatus.CALL_UNEXPECTED_ERROR:
            return "_UniffiRustCallStatus(CALL_UNEXPECTED_ERROR)"
        else:
            return "_UniffiRustCallStatus(<invalid code>)"

def _rust_call(fn, *args):
    # Call a rust function
    return _rust_call_with_error(None, fn, *args)

def _rust_call_with_error(error_ffi_converter, fn, *args):
    # Call a rust function and handle any errors
    #
    # This function is used for rust calls that return Result<> and therefore can set the CALL_ERROR status code.
    # error_ffi_converter must be set to the _UniffiConverter for the error class that corresponds to the result.
    call_status = _UniffiRustCallStatus.default()

    args_with_error = args + (ctypes.byref(call_status),)
    result = fn(*args_with_error)
    _uniffi_check_call_status(error_ffi_converter, call_status)
    return result

def _uniffi_check_call_status(error_ffi_converter, call_status):
    if call_status.code == _UniffiRustCallStatus.CALL_SUCCESS:
        pass
    elif call_status.code == _UniffiRustCallStatus.CALL_ERROR:
        if error_ffi_converter is None:
            call_status.error_buf.free()
            raise InternalError("_rust_call_with_error: CALL_ERROR, but error_ffi_converter is None")
        else:
            raise error_ffi_converter.lift(call_status.error_buf)
    elif call_status.code == _UniffiRustCallStatus.CALL_UNEXPECTED_ERROR:
        # When the rust code sees a panic, it tries to construct a _UniffiRustBuffer
        # with the message.  But if that code panics, then it just sends back
        # an empty buffer.
        if call_status.error_buf.len > 0:
            msg = _UniffiConverterString.lift(call_status.error_buf)
        else:
            msg = "Unknown rust panic"
        raise InternalError(msg)
    else:
        raise InternalError("Invalid _UniffiRustCallStatus code: {}".format(
            call_status.code))

def _uniffi_trait_interface_call(call_status, make_call, write_return_value):
    try:
        return write_return_value(make_call())
    except Exception as e:
        call_status.code = _UniffiRustCallStatus.CALL_UNEXPECTED_ERROR
        call_status.error_buf = _UniffiConverterString.lower(repr(e))

def _uniffi_trait_interface_call_with_error(call_status, make_call, write_return_value, error_type, lower_error):
    try:
        try:
            return write_return_value(make_call())
        except error_type as e:
            call_status.code = _UniffiRustCallStatus.CALL_ERROR
            call_status.error_buf = lower_error(e)
    except Exception as e:
        call_status.code = _UniffiRustCallStatus.CALL_UNEXPECTED_ERROR
        call_status.error_buf = _UniffiConverterString.lower(repr(e))
class _UniffiHandleMap:
    """
    A map where inserting, getting and removing data is synchronized with a lock.
    """

    def __init__(self):
        # type Handle = int
        self._map = {}  # type: Dict[Handle, Any]
        self._lock = threading.Lock()
        self._counter = itertools.count()

    def insert(self, obj):
        with self._lock:
            handle = next(self._counter)
            self._map[handle] = obj
            return handle

    def get(self, handle):
        try:
            with self._lock:
                return self._map[handle]
        except KeyError:
            raise InternalError("UniffiHandleMap.get: Invalid handle")

    def remove(self, handle):
        try:
            with self._lock:
                return self._map.pop(handle)
        except KeyError:
            raise InternalError("UniffiHandleMap.remove: Invalid handle")

    def __len__(self):
        return len(self._map)
# Types conforming to `_UniffiConverterPrimitive` pass themselves directly over the FFI.
class _UniffiConverterPrimitive:
    @classmethod
    def lift(cls, value):
        return value

    @classmethod
    def lower(cls, value):
        return value

class _UniffiConverterPrimitiveInt(_UniffiConverterPrimitive):
    @classmethod
    def check_lower(cls, value):
        try:
            value = value.__index__()
        except Exception:
            raise TypeError("'{}' object cannot be interpreted as an integer".format(type(value).__name__))
        if not isinstance(value, int):
            raise TypeError("__index__ returned non-int (type {})".format(type(value).__name__))
        if not cls.VALUE_MIN <= value < cls.VALUE_MAX:
            raise ValueError("{} requires {} <= value < {}".format(cls.CLASS_NAME, cls.VALUE_MIN, cls.VALUE_MAX))

class _UniffiConverterPrimitiveFloat(_UniffiConverterPrimitive):
    @classmethod
    def check_lower(cls, value):
        try:
            value = value.__float__()
        except Exception:
            raise TypeError("must be real number, not {}".format(type(value).__name__))
        if not isinstance(value, float):
            raise TypeError("__float__ returned non-float (type {})".format(type(value).__name__))

# Helper class for wrapper types that will always go through a _UniffiRustBuffer.
# Classes should inherit from this and implement the `read` and `write` static methods.
class _UniffiConverterRustBuffer:
    @classmethod
    def lift(cls, rbuf):
        with rbuf.consume_with_stream() as stream:
            return cls.read(stream)

    @classmethod
    def lower(cls, value):
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            cls.write(value, builder)
            return builder.finalize()

# Contains loading, initialization code, and the FFI Function declarations.
# Define some ctypes FFI types that we use in the library

"""
Function pointer for a Rust task, which a callback function that takes a opaque pointer
"""
_UNIFFI_RUST_TASK = ctypes.CFUNCTYPE(None, ctypes.c_void_p, ctypes.c_int8)

def _uniffi_future_callback_t(return_type):
    """
    Factory function to create callback function types for async functions
    """
    return ctypes.CFUNCTYPE(None, ctypes.c_uint64, return_type, _UniffiRustCallStatus)

def _uniffi_load_indirect():
    """
    This is how we find and load the dynamic library provided by the component.
    For now we just look it up by name.
    """
    if sys.platform == "darwin":
        libname = "lib{}.dylib"
    elif sys.platform.startswith("win"):
        # As of python3.8, ctypes does not seem to search $PATH when loading DLLs.
        # We could use `os.add_dll_directory` to configure the search path, but
        # it doesn't feel right to mess with application-wide settings. Let's
        # assume that the `.dll` is next to the `.py` file and load by full path.
        libname = os.path.join(
            os.path.dirname(__file__),
            "{}.dll",
        )
    else:
        # Anything else must be an ELF platform - Linux, *BSD, Solaris/illumos
        libname = "lib{}.so"

    libname = libname.format("uniffi_ceylon")
    path = os.path.join(os.path.dirname(__file__), libname)
    lib = ctypes.cdll.LoadLibrary(path)
    return lib

def _uniffi_check_contract_api_version(lib):
    # Get the bindings contract version from our ComponentInterface
    bindings_contract_version = 26
    # Get the scaffolding contract version by calling the into the dylib
    scaffolding_contract_version = lib.ffi_ceylon_uniffi_contract_version()
    if bindings_contract_version != scaffolding_contract_version:
        raise InternalError("UniFFI contract version mismatch: try cleaning and rebuilding your project")

def _uniffi_check_api_checksums(lib):
    if lib.uniffi_ceylon_checksum_func_version() != 8017:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_agentcore_broadcast() != 57054:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_agentcore_id() != 34125:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_agentcore_is_leader() != 35579:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_agentcore_name() != 23786:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_agentcore_workspace_id() != 28110:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_messagehandler_on_message() != 59448:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_processor_run() != 17701:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_method_workspace_run() != 58207:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_constructor_agentcore_new() != 21222:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_ceylon_checksum_constructor_workspace_new() != 20852:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")

# A ctypes library to expose the extern-C FFI definitions.
# This is an implementation detail which will be called internally by the public API.

_UniffiLib = _uniffi_load_indirect()
UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK = ctypes.CFUNCTYPE(None,ctypes.c_uint64,ctypes.c_int8,
)
UNIFFI_FOREIGN_FUTURE_FREE = ctypes.CFUNCTYPE(None,ctypes.c_uint64,
)
UNIFFI_CALLBACK_INTERFACE_FREE = ctypes.CFUNCTYPE(None,ctypes.c_uint64,
)
class UniffiForeignFuture(ctypes.Structure):
    _fields_ = [
        ("handle", ctypes.c_uint64),
        ("free", UNIFFI_FOREIGN_FUTURE_FREE),
    ]
class UniffiForeignFutureStructU8(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_uint8),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_U8 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructU8,
)
class UniffiForeignFutureStructI8(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_int8),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_I8 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructI8,
)
class UniffiForeignFutureStructU16(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_uint16),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_U16 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructU16,
)
class UniffiForeignFutureStructI16(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_int16),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_I16 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructI16,
)
class UniffiForeignFutureStructU32(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_uint32),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_U32 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructU32,
)
class UniffiForeignFutureStructI32(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_int32),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_I32 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructI32,
)
class UniffiForeignFutureStructU64(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_uint64),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_U64 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructU64,
)
class UniffiForeignFutureStructI64(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_int64),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_I64 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructI64,
)
class UniffiForeignFutureStructF32(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_float),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_F32 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructF32,
)
class UniffiForeignFutureStructF64(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_double),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_F64 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructF64,
)
class UniffiForeignFutureStructPointer(ctypes.Structure):
    _fields_ = [
        ("return_value", ctypes.c_void_p),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_POINTER = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructPointer,
)
class UniffiForeignFutureStructRustBuffer(ctypes.Structure):
    _fields_ = [
        ("return_value", _UniffiRustBuffer),
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_RUST_BUFFER = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructRustBuffer,
)
class UniffiForeignFutureStructVoid(ctypes.Structure):
    _fields_ = [
        ("call_status", _UniffiRustCallStatus),
    ]
UNIFFI_FOREIGN_FUTURE_COMPLETE_VOID = ctypes.CFUNCTYPE(None,ctypes.c_uint64,UniffiForeignFutureStructVoid,
)
UNIFFI_CALLBACK_INTERFACE_MESSAGE_HANDLER_METHOD0 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,_UniffiRustBuffer,_UniffiRustBuffer,UNIFFI_FOREIGN_FUTURE_COMPLETE_VOID,ctypes.c_uint64,ctypes.POINTER(UniffiForeignFuture),
)
UNIFFI_CALLBACK_INTERFACE_PROCESSOR_METHOD0 = ctypes.CFUNCTYPE(None,ctypes.c_uint64,_UniffiRustBuffer,UNIFFI_FOREIGN_FUTURE_COMPLETE_VOID,ctypes.c_uint64,ctypes.POINTER(UniffiForeignFuture),
)
class UniffiVTableCallbackInterfaceMessageHandler(ctypes.Structure):
    _fields_ = [
        ("on_message", UNIFFI_CALLBACK_INTERFACE_MESSAGE_HANDLER_METHOD0),
        ("uniffi_free", UNIFFI_CALLBACK_INTERFACE_FREE),
    ]
class UniffiVTableCallbackInterfaceProcessor(ctypes.Structure):
    _fields_ = [
        ("run", UNIFFI_CALLBACK_INTERFACE_PROCESSOR_METHOD0),
        ("uniffi_free", UNIFFI_CALLBACK_INTERFACE_FREE),
    ]
_UniffiLib.uniffi_ceylon_fn_clone_agentcore.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_clone_agentcore.restype = ctypes.c_void_p
_UniffiLib.uniffi_ceylon_fn_free_agentcore.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_free_agentcore.restype = None
_UniffiLib.uniffi_ceylon_fn_constructor_agentcore_new.argtypes = (
    _UniffiRustBuffer,
    ctypes.c_int8,
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_constructor_agentcore_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_ceylon_fn_method_agentcore_broadcast.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_ceylon_fn_method_agentcore_broadcast.restype = ctypes.c_uint64
_UniffiLib.uniffi_ceylon_fn_method_agentcore_id.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_method_agentcore_id.restype = _UniffiRustBuffer
_UniffiLib.uniffi_ceylon_fn_method_agentcore_is_leader.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_method_agentcore_is_leader.restype = ctypes.c_int8
_UniffiLib.uniffi_ceylon_fn_method_agentcore_name.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_method_agentcore_name.restype = _UniffiRustBuffer
_UniffiLib.uniffi_ceylon_fn_method_agentcore_workspace_id.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_method_agentcore_workspace_id.restype = _UniffiRustBuffer
_UniffiLib.uniffi_ceylon_fn_clone_messagehandler.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_clone_messagehandler.restype = ctypes.c_void_p
_UniffiLib.uniffi_ceylon_fn_free_messagehandler.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_free_messagehandler.restype = None
_UniffiLib.uniffi_ceylon_fn_init_callback_vtable_messagehandler.argtypes = (
    ctypes.POINTER(UniffiVTableCallbackInterfaceMessageHandler),
)
_UniffiLib.uniffi_ceylon_fn_init_callback_vtable_messagehandler.restype = None
_UniffiLib.uniffi_ceylon_fn_method_messagehandler_on_message.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_ceylon_fn_method_messagehandler_on_message.restype = ctypes.c_uint64
_UniffiLib.uniffi_ceylon_fn_clone_processor.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_clone_processor.restype = ctypes.c_void_p
_UniffiLib.uniffi_ceylon_fn_free_processor.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_free_processor.restype = None
_UniffiLib.uniffi_ceylon_fn_init_callback_vtable_processor.argtypes = (
    ctypes.POINTER(UniffiVTableCallbackInterfaceProcessor),
)
_UniffiLib.uniffi_ceylon_fn_init_callback_vtable_processor.restype = None
_UniffiLib.uniffi_ceylon_fn_method_processor_run.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_ceylon_fn_method_processor_run.restype = ctypes.c_uint64
_UniffiLib.uniffi_ceylon_fn_clone_workspace.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_clone_workspace.restype = ctypes.c_void_p
_UniffiLib.uniffi_ceylon_fn_free_workspace.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_free_workspace.restype = None
_UniffiLib.uniffi_ceylon_fn_constructor_workspace_new.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_constructor_workspace_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_ceylon_fn_method_workspace_run.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_ceylon_fn_method_workspace_run.restype = ctypes.c_uint64
_UniffiLib.uniffi_ceylon_fn_func_version.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_ceylon_fn_func_version.restype = _UniffiRustBuffer
_UniffiLib.ffi_ceylon_rustbuffer_alloc.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rustbuffer_alloc.restype = _UniffiRustBuffer
_UniffiLib.ffi_ceylon_rustbuffer_from_bytes.argtypes = (
    _UniffiForeignBytes,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rustbuffer_from_bytes.restype = _UniffiRustBuffer
_UniffiLib.ffi_ceylon_rustbuffer_free.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rustbuffer_free.restype = None
_UniffiLib.ffi_ceylon_rustbuffer_reserve.argtypes = (
    _UniffiRustBuffer,
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rustbuffer_reserve.restype = _UniffiRustBuffer
_UniffiLib.ffi_ceylon_rust_future_poll_u8.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_u8.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_u8.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_u8.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_u8.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_u8.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_u8.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_u8.restype = ctypes.c_uint8
_UniffiLib.ffi_ceylon_rust_future_poll_i8.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_i8.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_i8.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_i8.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_i8.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_i8.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_i8.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_i8.restype = ctypes.c_int8
_UniffiLib.ffi_ceylon_rust_future_poll_u16.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_u16.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_u16.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_u16.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_u16.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_u16.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_u16.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_u16.restype = ctypes.c_uint16
_UniffiLib.ffi_ceylon_rust_future_poll_i16.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_i16.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_i16.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_i16.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_i16.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_i16.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_i16.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_i16.restype = ctypes.c_int16
_UniffiLib.ffi_ceylon_rust_future_poll_u32.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_u32.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_u32.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_u32.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_u32.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_u32.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_u32.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_u32.restype = ctypes.c_uint32
_UniffiLib.ffi_ceylon_rust_future_poll_i32.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_i32.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_i32.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_i32.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_i32.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_i32.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_i32.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_i32.restype = ctypes.c_int32
_UniffiLib.ffi_ceylon_rust_future_poll_u64.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_u64.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_u64.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_u64.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_u64.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_u64.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_u64.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_u64.restype = ctypes.c_uint64
_UniffiLib.ffi_ceylon_rust_future_poll_i64.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_i64.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_i64.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_i64.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_i64.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_i64.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_i64.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_i64.restype = ctypes.c_int64
_UniffiLib.ffi_ceylon_rust_future_poll_f32.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_f32.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_f32.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_f32.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_f32.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_f32.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_f32.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_f32.restype = ctypes.c_float
_UniffiLib.ffi_ceylon_rust_future_poll_f64.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_f64.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_f64.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_f64.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_f64.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_f64.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_f64.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_f64.restype = ctypes.c_double
_UniffiLib.ffi_ceylon_rust_future_poll_pointer.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_pointer.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_pointer.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_pointer.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_pointer.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_pointer.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_pointer.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_pointer.restype = ctypes.c_void_p
_UniffiLib.ffi_ceylon_rust_future_poll_rust_buffer.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_rust_buffer.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_rust_buffer.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_rust_buffer.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_rust_buffer.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_rust_buffer.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_rust_buffer.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_rust_buffer.restype = _UniffiRustBuffer
_UniffiLib.ffi_ceylon_rust_future_poll_void.argtypes = (
    ctypes.c_uint64,
    UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK,
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_poll_void.restype = None
_UniffiLib.ffi_ceylon_rust_future_cancel_void.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_cancel_void.restype = None
_UniffiLib.ffi_ceylon_rust_future_free_void.argtypes = (
    ctypes.c_uint64,
)
_UniffiLib.ffi_ceylon_rust_future_free_void.restype = None
_UniffiLib.ffi_ceylon_rust_future_complete_void.argtypes = (
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_ceylon_rust_future_complete_void.restype = None
_UniffiLib.uniffi_ceylon_checksum_func_version.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_func_version.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_broadcast.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_broadcast.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_id.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_id.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_is_leader.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_is_leader.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_name.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_name.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_workspace_id.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_agentcore_workspace_id.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_messagehandler_on_message.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_messagehandler_on_message.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_processor_run.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_processor_run.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_method_workspace_run.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_method_workspace_run.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_constructor_agentcore_new.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_constructor_agentcore_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_ceylon_checksum_constructor_workspace_new.argtypes = (
)
_UniffiLib.uniffi_ceylon_checksum_constructor_workspace_new.restype = ctypes.c_uint16
_UniffiLib.ffi_ceylon_uniffi_contract_version.argtypes = (
)
_UniffiLib.ffi_ceylon_uniffi_contract_version.restype = ctypes.c_uint32

_uniffi_check_contract_api_version(_UniffiLib)
_uniffi_check_api_checksums(_UniffiLib)

# Public interface members begin here.


class _UniffiConverterUInt16(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u16"
    VALUE_MIN = 0
    VALUE_MAX = 2**16

    @staticmethod
    def read(buf):
        return buf.read_u16()

    @staticmethod
    def write(value, buf):
        buf.write_u16(value)

class _UniffiConverterUInt64(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u64"
    VALUE_MIN = 0
    VALUE_MAX = 2**64

    @staticmethod
    def read(buf):
        return buf.read_u64()

    @staticmethod
    def write(value, buf):
        buf.write_u64(value)

class _UniffiConverterBool:
    @classmethod
    def check_lower(cls, value):
        return not not value

    @classmethod
    def lower(cls, value):
        return 1 if value else 0

    @staticmethod
    def lift(value):
        return value != 0

    @classmethod
    def read(cls, buf):
        return cls.lift(buf.read_u8())

    @classmethod
    def write(cls, value, buf):
        buf.write_u8(value)

class _UniffiConverterString:
    @staticmethod
    def check_lower(value):
        if not isinstance(value, str):
            raise TypeError("argument must be str, not {}".format(type(value).__name__))
        return value

    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative string length")
        utf8_bytes = buf.read(size)
        return utf8_bytes.decode("utf-8")

    @staticmethod
    def write(value, buf):
        utf8_bytes = value.encode("utf-8")
        buf.write_i32(len(utf8_bytes))
        buf.write(utf8_bytes)

    @staticmethod
    def lift(buf):
        with buf.consume_with_stream() as stream:
            return stream.read(stream.remaining()).decode("utf-8")

    @staticmethod
    def lower(value):
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            builder.write(value.encode("utf-8"))
            return builder.finalize()

class _UniffiConverterBytes(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative byte string length")
        return buf.read(size)

    @staticmethod
    def check_lower(value):
        try:
            memoryview(value)
        except TypeError:
            raise TypeError("a bytes-like object is required, not {!r}".format(type(value).__name__))

    @staticmethod
    def write(value, buf):
        buf.write_i32(len(value))
        buf.write(value)



class AgentCoreProtocol(typing.Protocol):
    def broadcast(self, message: "bytes"):
        raise NotImplementedError
    def id(self, ):
        raise NotImplementedError
    def is_leader(self, ):
        raise NotImplementedError
    def name(self, ):
        raise NotImplementedError
    def workspace_id(self, ):
        raise NotImplementedError


class AgentCore:
    _pointer: ctypes.c_void_p
    def __init__(self, name: "str",is_leader: "bool",on_message: "MessageHandler",processor: "Processor"):
        _UniffiConverterString.check_lower(name)
        
        _UniffiConverterBool.check_lower(is_leader)
        
        _UniffiConverterTypeMessageHandler.check_lower(on_message)
        
        _UniffiConverterTypeProcessor.check_lower(processor)
        
        self._pointer = _rust_call(_UniffiLib.uniffi_ceylon_fn_constructor_agentcore_new,
        _UniffiConverterString.lower(name),
        _UniffiConverterBool.lower(is_leader),
        _UniffiConverterTypeMessageHandler.lower(on_message),
        _UniffiConverterTypeProcessor.lower(processor))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_ceylon_fn_free_agentcore, pointer)

    def _uniffi_clone_pointer(self):
        return _rust_call(_UniffiLib.uniffi_ceylon_fn_clone_agentcore, self._pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    async def broadcast(self, message: "bytes") -> None:

        _UniffiConverterBytes.check_lower(message)
        
        return await _uniffi_rust_call_async(
            _UniffiLib.uniffi_ceylon_fn_method_agentcore_broadcast(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(message)
            ),
            _UniffiLib.ffi_ceylon_rust_future_poll_void,
            _UniffiLib.ffi_ceylon_rust_future_complete_void,
            _UniffiLib.ffi_ceylon_rust_future_free_void,
            # lift function
            lambda val: None,
            
            
    # Error FFI converter

    None,

        )




    def id(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_ceylon_fn_method_agentcore_id,self._uniffi_clone_pointer(),)
        )





    def is_leader(self, ) -> "bool":
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_ceylon_fn_method_agentcore_is_leader,self._uniffi_clone_pointer(),)
        )





    def name(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_ceylon_fn_method_agentcore_name,self._uniffi_clone_pointer(),)
        )





    def workspace_id(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_ceylon_fn_method_agentcore_workspace_id,self._uniffi_clone_pointer(),)
        )






class _UniffiConverterTypeAgentCore:

    @staticmethod
    def lift(value: int):
        return AgentCore._make_instance_(value)

    @staticmethod
    def check_lower(value: AgentCore):
        if not isinstance(value, AgentCore):
            raise TypeError("Expected AgentCore instance, {} found".format(type(value).__name__))

    @staticmethod
    def lower(value: AgentCoreProtocol):
        if not isinstance(value, AgentCore):
            raise TypeError("Expected AgentCore instance, {} found".format(type(value).__name__))
        return value._uniffi_clone_pointer()

    @classmethod
    def read(cls, buf: _UniffiRustBuffer):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value: AgentCoreProtocol, buf: _UniffiRustBuffer):
        buf.write_u64(cls.lower(value))



class MessageHandler(typing.Protocol):
    def on_message(self, agent_id: "str",message: "Message"):
        raise NotImplementedError


class MessageHandlerImpl:
    _pointer: ctypes.c_void_p
    
    def __init__(self, *args, **kwargs):
        raise ValueError("This class has no default constructor")

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_ceylon_fn_free_messagehandler, pointer)

    def _uniffi_clone_pointer(self):
        return _rust_call(_UniffiLib.uniffi_ceylon_fn_clone_messagehandler, self._pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    async def on_message(self, agent_id: "str",message: "Message") -> None:

        _UniffiConverterString.check_lower(agent_id)
        
        _UniffiConverterTypeMessage.check_lower(message)
        
        return await _uniffi_rust_call_async(
            _UniffiLib.uniffi_ceylon_fn_method_messagehandler_on_message(
                self._uniffi_clone_pointer(), 
        _UniffiConverterString.lower(agent_id),
        _UniffiConverterTypeMessage.lower(message)
            ),
            _UniffiLib.ffi_ceylon_rust_future_poll_void,
            _UniffiLib.ffi_ceylon_rust_future_complete_void,
            _UniffiLib.ffi_ceylon_rust_future_free_void,
            # lift function
            lambda val: None,
            
            
    # Error FFI converter

    None,

        )


# Magic number for the Rust proxy to call using the same mechanism as every other method,
# to free the callback once it's dropped by Rust.
IDX_CALLBACK_FREE = 0
# Return codes for callback calls
_UNIFFI_CALLBACK_SUCCESS = 0
_UNIFFI_CALLBACK_ERROR = 1
_UNIFFI_CALLBACK_UNEXPECTED_ERROR = 2

class UniffiCallbackInterfaceFfiConverter:
    _handle_map = _UniffiHandleMap()

    @classmethod
    def lift(cls, handle):
        return cls._handle_map.get(handle)

    @classmethod
    def read(cls, buf):
        handle = buf.read_u64()
        cls.lift(handle)

    @classmethod
    def check_lower(cls, cb):
        pass

    @classmethod
    def lower(cls, cb):
        handle = cls._handle_map.insert(cb)
        return handle

    @classmethod
    def write(cls, cb, buf):
        buf.write_u64(cls.lower(cb))

# Put all the bits inside a class to keep the top-level namespace clean
class UniffiTraitImplMessageHandler:
    # For each method, generate a callback function to pass to Rust

    @UNIFFI_CALLBACK_INTERFACE_MESSAGE_HANDLER_METHOD0
    def on_message(
            uniffi_handle,
            agent_id,
            message,
            uniffi_future_callback,
            uniffi_callback_data,
            uniffi_out_return,
        ):
        uniffi_obj = _UniffiConverterTypeMessageHandler._handle_map.get(uniffi_handle)
        def make_call():
            args = (_UniffiConverterString.lift(agent_id), _UniffiConverterTypeMessage.lift(message), )
            method = uniffi_obj.on_message
            return method(*args)

        
        def handle_success(return_value):
            uniffi_future_callback(
                uniffi_callback_data,
                UniffiForeignFutureStructVoid(
                    _UniffiRustCallStatus.default()
                )
            )

        def handle_error(status_code, rust_buffer):
            uniffi_future_callback(
                uniffi_callback_data,
                UniffiForeignFutureStructVoid(
                    _UniffiRustCallStatus(status_code, rust_buffer),
                )
            )
        uniffi_out_return[0] = uniffi_trait_interface_call_async(make_call, handle_success, handle_error)

    @UNIFFI_CALLBACK_INTERFACE_FREE
    def uniffi_free(uniffi_handle):
        _UniffiConverterTypeMessageHandler._handle_map.remove(uniffi_handle)

    # Generate the FFI VTable.  This has a field for each callback interface method.
    uniffi_vtable = UniffiVTableCallbackInterfaceMessageHandler(
        on_message,
        uniffi_free
    )
    # Send Rust a pointer to the VTable.  Note: this means we need to keep the struct alive forever,
    # or else bad things will happen when Rust tries to access it.
    _UniffiLib.uniffi_ceylon_fn_init_callback_vtable_messagehandler(ctypes.byref(uniffi_vtable))



class _UniffiConverterTypeMessageHandler:
    _handle_map = _UniffiHandleMap()

    @staticmethod
    def lift(value: int):
        return MessageHandlerImpl._make_instance_(value)

    @staticmethod
    def check_lower(value: MessageHandler):
        pass

    @staticmethod
    def lower(value: MessageHandler):
        return _UniffiConverterTypeMessageHandler._handle_map.insert(value)

    @classmethod
    def read(cls, buf: _UniffiRustBuffer):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value: MessageHandler, buf: _UniffiRustBuffer):
        buf.write_u64(cls.lower(value))



class Processor(typing.Protocol):
    def run(self, inputs: "dict[str, str]"):
        raise NotImplementedError


class ProcessorImpl:
    _pointer: ctypes.c_void_p
    
    def __init__(self, *args, **kwargs):
        raise ValueError("This class has no default constructor")

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_ceylon_fn_free_processor, pointer)

    def _uniffi_clone_pointer(self):
        return _rust_call(_UniffiLib.uniffi_ceylon_fn_clone_processor, self._pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    async def run(self, inputs: "dict[str, str]") -> None:

        _UniffiConverterMapStringString.check_lower(inputs)
        
        return await _uniffi_rust_call_async(
            _UniffiLib.uniffi_ceylon_fn_method_processor_run(
                self._uniffi_clone_pointer(), 
        _UniffiConverterMapStringString.lower(inputs)
            ),
            _UniffiLib.ffi_ceylon_rust_future_poll_void,
            _UniffiLib.ffi_ceylon_rust_future_complete_void,
            _UniffiLib.ffi_ceylon_rust_future_free_void,
            # lift function
            lambda val: None,
            
            
    # Error FFI converter

    None,

        )




# Put all the bits inside a class to keep the top-level namespace clean
class UniffiTraitImplProcessor:
    # For each method, generate a callback function to pass to Rust

    @UNIFFI_CALLBACK_INTERFACE_PROCESSOR_METHOD0
    def run(
            uniffi_handle,
            inputs,
            uniffi_future_callback,
            uniffi_callback_data,
            uniffi_out_return,
        ):
        uniffi_obj = _UniffiConverterTypeProcessor._handle_map.get(uniffi_handle)
        def make_call():
            args = (_UniffiConverterMapStringString.lift(inputs), )
            method = uniffi_obj.run
            return method(*args)

        
        def handle_success(return_value):
            uniffi_future_callback(
                uniffi_callback_data,
                UniffiForeignFutureStructVoid(
                    _UniffiRustCallStatus.default()
                )
            )

        def handle_error(status_code, rust_buffer):
            uniffi_future_callback(
                uniffi_callback_data,
                UniffiForeignFutureStructVoid(
                    _UniffiRustCallStatus(status_code, rust_buffer),
                )
            )
        uniffi_out_return[0] = uniffi_trait_interface_call_async(make_call, handle_success, handle_error)

    @UNIFFI_CALLBACK_INTERFACE_FREE
    def uniffi_free(uniffi_handle):
        _UniffiConverterTypeProcessor._handle_map.remove(uniffi_handle)

    # Generate the FFI VTable.  This has a field for each callback interface method.
    uniffi_vtable = UniffiVTableCallbackInterfaceProcessor(
        run,
        uniffi_free
    )
    # Send Rust a pointer to the VTable.  Note: this means we need to keep the struct alive forever,
    # or else bad things will happen when Rust tries to access it.
    _UniffiLib.uniffi_ceylon_fn_init_callback_vtable_processor(ctypes.byref(uniffi_vtable))



class _UniffiConverterTypeProcessor:
    _handle_map = _UniffiHandleMap()

    @staticmethod
    def lift(value: int):
        return ProcessorImpl._make_instance_(value)

    @staticmethod
    def check_lower(value: Processor):
        pass

    @staticmethod
    def lower(value: Processor):
        return _UniffiConverterTypeProcessor._handle_map.insert(value)

    @classmethod
    def read(cls, buf: _UniffiRustBuffer):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value: Processor, buf: _UniffiRustBuffer):
        buf.write_u64(cls.lower(value))



class WorkspaceProtocol(typing.Protocol):
    def run(self, inputs: "dict[str, str]"):
        raise NotImplementedError


class Workspace:
    _pointer: ctypes.c_void_p
    def __init__(self, agents: "typing.List[AgentCore]",config: "WorkspaceConfig"):
        _UniffiConverterSequenceTypeAgentCore.check_lower(agents)
        
        _UniffiConverterTypeWorkspaceConfig.check_lower(config)
        
        self._pointer = _rust_call(_UniffiLib.uniffi_ceylon_fn_constructor_workspace_new,
        _UniffiConverterSequenceTypeAgentCore.lower(agents),
        _UniffiConverterTypeWorkspaceConfig.lower(config))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_ceylon_fn_free_workspace, pointer)

    def _uniffi_clone_pointer(self):
        return _rust_call(_UniffiLib.uniffi_ceylon_fn_clone_workspace, self._pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    async def run(self, inputs: "dict[str, str]") -> None:

        _UniffiConverterMapStringString.check_lower(inputs)
        
        return await _uniffi_rust_call_async(
            _UniffiLib.uniffi_ceylon_fn_method_workspace_run(
                self._uniffi_clone_pointer(), 
        _UniffiConverterMapStringString.lower(inputs)
            ),
            _UniffiLib.ffi_ceylon_rust_future_poll_void,
            _UniffiLib.ffi_ceylon_rust_future_complete_void,
            _UniffiLib.ffi_ceylon_rust_future_free_void,
            # lift function
            lambda val: None,
            
            
    # Error FFI converter

    None,

        )





class _UniffiConverterTypeWorkspace:

    @staticmethod
    def lift(value: int):
        return Workspace._make_instance_(value)

    @staticmethod
    def check_lower(value: Workspace):
        if not isinstance(value, Workspace):
            raise TypeError("Expected Workspace instance, {} found".format(type(value).__name__))

    @staticmethod
    def lower(value: WorkspaceProtocol):
        if not isinstance(value, Workspace):
            raise TypeError("Expected Workspace instance, {} found".format(type(value).__name__))
        return value._uniffi_clone_pointer()

    @classmethod
    def read(cls, buf: _UniffiRustBuffer):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value: WorkspaceProtocol, buf: _UniffiRustBuffer):
        buf.write_u64(cls.lower(value))


class Message:
    data: "bytes"
    message: "str"
    time: "int"
    originator: "str"
    originator_id: "str"
    type: "MessageType"
    @typing.no_type_check
    def __init__(self, *, data: "bytes", message: "str", time: "int", originator: "str", originator_id: "str", type: "MessageType"):
        self.data = data
        self.message = message
        self.time = time
        self.originator = originator
        self.originator_id = originator_id
        self.type = type

    def __str__(self):
        return "Message(data={}, message={}, time={}, originator={}, originator_id={}, type={})".format(self.data, self.message, self.time, self.originator, self.originator_id, self.type)

    def __eq__(self, other):
        if self.data != other.data:
            return False
        if self.message != other.message:
            return False
        if self.time != other.time:
            return False
        if self.originator != other.originator:
            return False
        if self.originator_id != other.originator_id:
            return False
        if self.type != other.type:
            return False
        return True

class _UniffiConverterTypeMessage(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return Message(
            data=_UniffiConverterBytes.read(buf),
            message=_UniffiConverterString.read(buf),
            time=_UniffiConverterUInt64.read(buf),
            originator=_UniffiConverterString.read(buf),
            originator_id=_UniffiConverterString.read(buf),
            type=_UniffiConverterTypeMessageType.read(buf),
        )

    @staticmethod
    def check_lower(value):
        _UniffiConverterBytes.check_lower(value.data)
        _UniffiConverterString.check_lower(value.message)
        _UniffiConverterUInt64.check_lower(value.time)
        _UniffiConverterString.check_lower(value.originator)
        _UniffiConverterString.check_lower(value.originator_id)
        _UniffiConverterTypeMessageType.check_lower(value.type)

    @staticmethod
    def write(value, buf):
        _UniffiConverterBytes.write(value.data, buf)
        _UniffiConverterString.write(value.message, buf)
        _UniffiConverterUInt64.write(value.time, buf)
        _UniffiConverterString.write(value.originator, buf)
        _UniffiConverterString.write(value.originator_id, buf)
        _UniffiConverterTypeMessageType.write(value.type, buf)


class WorkspaceConfig:
    name: "str"
    host: "str"
    port: "int"
    @typing.no_type_check
    def __init__(self, *, name: "str", host: "str" = _DEFAULT, port: "int" = _DEFAULT):
        self.name = name
        if host is _DEFAULT:
            self.host = "/ip4/0.0.0.0/tcp/"
        else:
            self.host = host
        if port is _DEFAULT:
            self.port = 8888
        else:
            self.port = port

    def __str__(self):
        return "WorkspaceConfig(name={}, host={}, port={})".format(self.name, self.host, self.port)

    def __eq__(self, other):
        if self.name != other.name:
            return False
        if self.host != other.host:
            return False
        if self.port != other.port:
            return False
        return True

class _UniffiConverterTypeWorkspaceConfig(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return WorkspaceConfig(
            name=_UniffiConverterString.read(buf),
            host=_UniffiConverterString.read(buf),
            port=_UniffiConverterUInt16.read(buf),
        )

    @staticmethod
    def check_lower(value):
        _UniffiConverterString.check_lower(value.name)
        _UniffiConverterString.check_lower(value.host)
        _UniffiConverterUInt16.check_lower(value.port)

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.name, buf)
        _UniffiConverterString.write(value.host, buf)
        _UniffiConverterUInt16.write(value.port, buf)





class MessageType(enum.Enum):
    MESSAGE = 0
    
    EVENT = 1
    


class _UniffiConverterTypeMessageType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return MessageType.MESSAGE
        if variant == 2:
            return MessageType.EVENT
        raise InternalError("Raw enum value doesn't match any cases")

    @staticmethod
    def check_lower(value):
        if value == MessageType.MESSAGE:
            return
        if value == MessageType.EVENT:
            return
        raise ValueError(value)

    @staticmethod
    def write(value, buf):
        if value == MessageType.MESSAGE:
            buf.write_i32(1)
        if value == MessageType.EVENT:
            buf.write_i32(2)





class _UniffiConverterSequenceTypeAgentCore(_UniffiConverterRustBuffer):
    @classmethod
    def check_lower(cls, value):
        for item in value:
            _UniffiConverterTypeAgentCore.check_lower(item)

    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeAgentCore.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeAgentCore.read(buf) for i in range(count)
        ]



class _UniffiConverterMapStringString(_UniffiConverterRustBuffer):
    @classmethod
    def check_lower(cls, items):
        for (key, value) in items.items():
            _UniffiConverterString.check_lower(key)
            _UniffiConverterString.check_lower(value)

    @classmethod
    def write(cls, items, buf):
        buf.write_i32(len(items))
        for (key, value) in items.items():
            _UniffiConverterString.write(key, buf)
            _UniffiConverterString.write(value, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative map size")

        # It would be nice to use a dict comprehension,
        # but in Python 3.7 and before the evaluation order is not according to spec,
        # so we we're reading the value before the key.
        # This loop makes the order explicit: first reading the key, then the value.
        d = {}
        for i in range(count):
            key = _UniffiConverterString.read(buf)
            val = _UniffiConverterString.read(buf)
            d[key] = val
        return d

# Async support# RustFuturePoll values
_UNIFFI_RUST_FUTURE_POLL_READY = 0
_UNIFFI_RUST_FUTURE_POLL_MAYBE_READY = 1

# Stores futures for _uniffi_continuation_callback
_UniffiContinuationHandleMap = _UniffiHandleMap()

UNIFFI_GLOBAL_EVENT_LOOP = None

"""
Set the event loop to use for async functions

This is needed if some async functions run outside of the eventloop, for example:
    - A non-eventloop thread is spawned, maybe from `EventLoop.run_in_executor` or maybe from the
      Rust code spawning its own thread.
    - The Rust code calls an async callback method from a sync callback function, using something
      like `pollster` to block on the async call.

In this case, we need an event loop to run the Python async function, but there's no eventloop set
for the thread.  Use `uniffi_set_event_loop` to force an eventloop to be used in this case.
"""
def uniffi_set_event_loop(eventloop: asyncio.BaseEventLoop):
    global UNIFFI_GLOBAL_EVENT_LOOP
    UNIFFI_GLOBAL_EVENT_LOOP = eventloop

def _uniffi_get_event_loop():
    if UNIFFI_GLOBAL_EVENT_LOOP is not None:
        return UNIFFI_GLOBAL_EVENT_LOOP
    else:
        return asyncio.get_running_loop()

# Continuation callback for async functions
# lift the return value or error and resolve the future, causing the async function to resume.
@UNIFFI_RUST_FUTURE_CONTINUATION_CALLBACK
def _uniffi_continuation_callback(future_ptr, poll_code):
    (eventloop, future) = _UniffiContinuationHandleMap.remove(future_ptr)
    eventloop.call_soon_threadsafe(_uniffi_set_future_result, future, poll_code)

def _uniffi_set_future_result(future, poll_code):
    if not future.cancelled():
        future.set_result(poll_code)

async def _uniffi_rust_call_async(rust_future, ffi_poll, ffi_complete, ffi_free, lift_func, error_ffi_converter):
    try:
        eventloop = _uniffi_get_event_loop()

        # Loop and poll until we see a _UNIFFI_RUST_FUTURE_POLL_READY value
        while True:
            future = eventloop.create_future()
            ffi_poll(
                rust_future,
                _uniffi_continuation_callback,
                _UniffiContinuationHandleMap.insert((eventloop, future)),
            )
            poll_code = await future
            if poll_code == _UNIFFI_RUST_FUTURE_POLL_READY:
                break

        return lift_func(
            _rust_call_with_error(error_ffi_converter, ffi_complete, rust_future)
        )
    finally:
        ffi_free(rust_future)
def uniffi_trait_interface_call_async(make_call, handle_success, handle_error):
    async def make_call_and_call_callback():
        try:
            handle_success(await make_call())
        except Exception as e:
            print("UniFFI: Unhandled exception in trait interface call", file=sys.stderr)
            traceback.print_exc(file=sys.stderr)
            handle_error(
                _UniffiRustCallStatus.CALL_UNEXPECTED_ERROR,
                _UniffiConverterString.lower(repr(e)),
            )
    eventloop = _uniffi_get_event_loop()
    task = asyncio.run_coroutine_threadsafe(make_call_and_call_callback(), eventloop)
    handle = UNIFFI_FOREIGN_FUTURE_HANDLE_MAP.insert((eventloop, task))
    return UniffiForeignFuture(handle, uniffi_foreign_future_free)

def uniffi_trait_interface_call_async_with_error(make_call, handle_success, handle_error, error_type, lower_error):
    async def make_call_and_call_callback():
        try:
            try:
                handle_success(await make_call())
            except error_type as e:
                handle_error(
                    _UniffiRustCallStatus.CALL_ERROR,
                    lower_error(e),
                )
        except Exception as e:
            print("UniFFI: Unhandled exception in trait interface call", file=sys.stderr)
            traceback.print_exc(file=sys.stderr)
            handle_error(
                _UniffiRustCallStatus.CALL_UNEXPECTED_ERROR,
                _UniffiConverterString.lower(repr(e)),
            )
    eventloop = _uniffi_get_event_loop()
    task = asyncio.run_coroutine_threadsafe(make_call_and_call_callback(), eventloop)
    handle = UNIFFI_FOREIGN_FUTURE_HANDLE_MAP.insert((eventloop, task))
    return UniffiForeignFuture(handle, uniffi_foreign_future_free)

UNIFFI_FOREIGN_FUTURE_HANDLE_MAP = _UniffiHandleMap()

@UNIFFI_FOREIGN_FUTURE_FREE
def uniffi_foreign_future_free(handle):
    (eventloop, task) = UNIFFI_FOREIGN_FUTURE_HANDLE_MAP.remove(handle)
    eventloop.call_soon(uniffi_foreign_future_do_free, task)

def uniffi_foreign_future_do_free(task):
    if not task.done():
        task.cancel()

def version() -> "str":
    return _UniffiConverterString.lift(_rust_call(_UniffiLib.uniffi_ceylon_fn_func_version,))


__all__ = [
    "InternalError",
    "MessageType",
    "Message",
    "WorkspaceConfig",
    "version",
    "AgentCore",
    "MessageHandler",
    "Processor",
    "Workspace",
    "uniffi_set_event_loop",
]

